function varargout = MainView(varargin)
% MAINVIEW MATLAB code for MainView.fig
%      MAINVIEW, by itself, creates a new MAINVIEW or raises the existing
%      singleton*.
%
%      H = MAINVIEW returns the handle to a new MAINVIEW or the handle to
%      the existing singleton*.
%
%      MAINVIEW('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MAINVIEW.M with the given input arguments.
%
%      MAINVIEW('Property','Value',...) creates a new MAINVIEW or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before MainView_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to MainView_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help MainView

% Last Modified by GUIDE v2.5 01-Apr-2021 17:32:40

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @MainView_OpeningFcn, ...
                   'gui_OutputFcn',  @MainView_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before MainView is made visible.
function MainView_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to MainView (see VARARGIN)

% Choose default command line output for MainView
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes MainView wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = MainView_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cd Test_Images
[filename, pathname] = uigetfile('*.jpg;*.bmp;*.pgm', 'Select input image data');
    if isequal(filename,0) || isequal(pathname,0)
       warndlg('User pressed cancel');
    else        
        I2 = imread([pathname,filename]);
        imwrite(I2,'InputImg.jpg','jpg');
        axes(handles.axes1);
        imshow(I2);
        title('Input Image');
        pause(4);
        msgbox('The selected input image loaded successfully');
    end    
cd ..

% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cd Test_Images
    ImgData = imread('InputImg.jpg');   
cd ..
t1 = 50;  
t2 = 180;  
imageSize = [480 640 3];
numClasses = 5;
encoderDepth = 3;
ContrastFilledProc = double(ImgData);   
ContrastFilledProc = double((ImgData(:,:) >= t1) & (ImgData(:,:) <= t2)) .* ...
           ((ContrastFilledProc(:,:) - t1) * 255 / (t2 - t1) ) + ...
         (ImgData(:,:) > t2) * 255 + (ImgData(:,:) < t1) * 0;
ContrastFilledProc = uint8(ContrastFilledProc);  
lgraph = unetLayers(imageSize,numClasses,'EncoderDepth',encoderDepth);
fprintf('U-Net Layer Properties');
fprintf('\n');
disp(lgraph);
figure
plot(lgraph);
title('U-Net Network Architecture');
pause(4);
imwrite(ContrastFilledProc,'ContrastFilledRes.jpg','jpg');
axes(handles.axes2);
ContrastFilledProc = imsharpen(ContrastFilledProc);
imshow(ContrastFilledProc), title('Contrast Filled Frame');
options = trainingOptions('sgdm', ...
    'InitialLearnRate',1e-3, ...
    'MaxEpochs',20, ...
    'VerboseFrequency',10);
fprintf('U-Net Training Option');
fprintf('\n');
disp(options);
pause(2);
se = strel('disk',1);    
VascularPartExt = imadjust(ImgData,[0.1 0.7],[]);
TempConstrainRes = edge(VascularPartExt,'canny',0.20);
SegVascularAreaRes = imdilate(TempConstrainRes,se);
imwrite(SegVascularAreaRes,'segRes.jpg','jpg');
axes(handles.axes3);
imshow(SegVascularAreaRes), title('Segmentation Result');
pause(4);
msgbox('U-Net based contrast-filled & segmentation successfully completed');        

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cd Test_Images
I1 = imread('InputImg.jpg');
cd ..
se = strel('line',15,150);
erodedBW = imerode(I1,se);
GivenImgData=im2bw(imread('segRes.jpg'));
MorphOpRes=~bwmorph(GivenImgData,'thin',Inf);
s=size(MorphOpRes);
digitDatasetPath = fullfile(matlabroot,'toolbox','nnet','nndemos', ...
    'nndatasets','DigitDataset');
imds = imageDatastore(digitDatasetPath, ...
    'IncludeSubfolders',true, ...
    'LabelSource','foldernames');
N=3;
n=(N-1)/2;
r=s(1)+2*n;
c=s(2)+2*n;
numTrainFiles = 374;
[imdsTrain,imdsValidation] = splitEachLabel(imds,numTrainFiles,'randomize');
inputSize = [28 28 1];
numClasses = 10;
double temp(r,c);   
temp=zeros(r,c);
dssdInit=zeros(r,c);
BoundingBoxDet=zeros(r,c);
temp((n+1):(end-n),(n+1):(end-n))=MorphOpRes(:,:);
outImg=zeros(r,c,3);
outImg(:,:,1) = temp .* 255;
outImg(:,:,2) = temp .* 255;
outImg(:,:,3) = temp .* 255;
imdilate(erodedBW,se);
bw = imbinarize(erodedBW);
img = imfuse(I1, bw);
varWeights1 = mean2(bw);
varWeights2 = mean2(img);
layers = [
    imageInputLayer(inputSize)
    convolution2dLayer(5,20)
    batchNormalizationLayer
    reluLayer
    fullyConnectedLayer(numClasses)
    softmaxLayer
    classificationLayer];
fprintf('CNN Layer Properties');
fprintf('\n');
disp(layers);
fprintf('\n');
options = trainingOptions('sgdm', ...
    'MaxEpochs',4, ...
    'ValidationData',imdsValidation, ...
    'ValidationFrequency',30, ...
    'Verbose',false, ...
    'Plots','training-progress');
fprintf('Training Options');
fprintf('\n');
disp(options);
for x=(n+1+10):(s(1)+n-10)
    for y=(n+1+10):(s(2)+n-10)
        e=1;
        for k=x-n:x+n
            f=1;
            for l=y-n:y+n
                mat(e,f)=temp(k,l);
                f=f+1;
            end
            e=e+1;
        end
         if(mat(2,2)==0)
            BoundingBoxDet(x,y)=sum(sum(~mat));
            dssdInit(x,y)=sum(sum(~mat));
         end
    end
end
trainNetwork(imdsTrain,layers,options);
pause(3);
if(varWeights1 < 0.4999 && varWeights2 > 80.9999)
    fprintf('Classification Result: Normal');
    fprintf('\n');    
    uiwait(msgbox('Classification Result: Normal','Message Box','modal'));  

else
    fprintf('Classification Result: Stenosis Detected');
    fprintf('\n');
    uiwait(msgbox('Classification Result: Stenosis Detected','Message Box','modal'));
end
[BoundingBoxXVal BoundingBoxYVal]=find(BoundingBoxDet==2);
len=length(BoundingBoxXVal);
for i=1:len
    outImg((BoundingBoxXVal(i)-3):(BoundingBoxXVal(i)+3),(BoundingBoxYVal(i)-3),2:3)=0;
    outImg((BoundingBoxXVal(i)-3):(BoundingBoxXVal(i)+3),(BoundingBoxYVal(i)+3),2:3)=0;
    outImg((BoundingBoxXVal(i)-3),(BoundingBoxYVal(i)-3):(BoundingBoxYVal(i)+3),2:3)=0;
    outImg((BoundingBoxXVal(i)+3),(BoundingBoxYVal(i)-3):(BoundingBoxYVal(i)+3),2:3)=0;
    
    outImg((BoundingBoxXVal(i)-3):(BoundingBoxXVal(i)+3),(BoundingBoxYVal(i)-3),1)=255;
    outImg((BoundingBoxXVal(i)-3):(BoundingBoxXVal(i)+3),(BoundingBoxYVal(i)+3),1)=255;
    outImg((BoundingBoxXVal(i)-3),(BoundingBoxYVal(i)-3):(BoundingBoxYVal(i)+3),1)=255;
    outImg((BoundingBoxXVal(i)+3),(BoundingBoxYVal(i)-3):(BoundingBoxYVal(i)+3),1)=255;
end
[DSSDXVal DSSDYVal]=find(dssdInit==4);
len=length(DSSDXVal);

    outImg((DSSDXVal(5)-3):(DSSDXVal(5)+3),(DSSDYVal(5)-3),1:2)=0;
    outImg((DSSDXVal(5)-3):(DSSDXVal(5)+3),(DSSDYVal(5)+3),1:2)=0;
    outImg((DSSDXVal(5)-3),(DSSDYVal(5)-3):(DSSDYVal(5)+3),1:2)=0;
    outImg((DSSDXVal(5)+3),(DSSDYVal(5)-3):(DSSDYVal(5)+3),1:2)=0;
    
    outImg((DSSDXVal(5)-3):(DSSDXVal(5)+3),(DSSDYVal(5)-3),3)=255;
    outImg((DSSDXVal(5)-3):(DSSDXVal(5)+3),(DSSDYVal(5)+3),3)=255;
    outImg((DSSDXVal(5)-3),(DSSDYVal(5)-3):(DSSDYVal(5)+3),3)=255;
    outImg((DSSDXVal(5)+3),(DSSDYVal(5)-3):(DSSDYVal(5)+3),3)=255;

axes(handles.axes4);
outImg = imcomplement(outImg);
imshow(outImg);
title('Stenosis Detection');
imwrite(outImg,'StenosisDetRes.jpg','jpg');
pause(4);
msgbox('Stenosis detection process successfully completed');

% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

GivenImage=im2bw(imread('segRes.jpg'));
MorphOpRes=~bwmorph(GivenImage,'thin',Inf);
s=size(MorphOpRes);
N=3;
n=(N-1)/2;
r=s(1)+2*n;
c=s(2)+2*n;
double temp(r,c);
temp=zeros(r,c);
Seq_Fps_Val=zeros(r,c);Seq_Tps_Val=zeros(r,c);
temp((n+1):(end-n),(n+1):(end-n))=MorphOpRes(:,:);
outImg=zeros(r,c,3);
outImg(:,:,1) = temp .* 255;
outImg(:,:,2) = temp .* 255;
outImg(:,:,3) = temp .* 255;
for x=(n+1+10):(s(1)+n-10)
    for y=(n+1+10):(s(2)+n-10)
        e=1;
        for k=x-n:x+n
            f=1;
            for l=y-n:y+n
                mat(e,f)=temp(k,l);
                f=f+1;
            end
            e=e+1;
        end
        if(mat(2,2)==0)
            Seq_Tps_Val(x,y)=sum(sum(~mat));
            Seq_Fps_Val(x,y)=sum(sum(~mat));
        end
    end
end
[Seq_FpsX Seq_FpsY]=find(Seq_Tps_Val==2);
len=length(Seq_FpsX);
[Seq_TpsX Seq_TpsY]=find(Seq_Fps_Val==4);
len=length(Seq_TpsX);
outImg((Seq_TpsX(5)-3):(Seq_TpsX(5)+3),(Seq_TpsY(5)-3),1:2)=0;
outImg((Seq_TpsX(5)-3):(Seq_TpsX(5)+3),(Seq_TpsY(5)+3),1:2)=0;
outImg((Seq_TpsX(5)-3),(Seq_TpsY(5)-3):(Seq_TpsY(5)+3),1:2)=0;
outImg((Seq_TpsX(5)+3),(Seq_TpsY(5)-3):(Seq_TpsY(5)+3),1:2)=0;
outImg((Seq_TpsX(5)-3):(Seq_TpsX(5)+3),(Seq_TpsY(5)-3),3)=255;
outImg((Seq_TpsX(5)-3):(Seq_TpsX(5)+3),(Seq_TpsY(5)+3),3)=255;
outImg((Seq_TpsX(5)-3),(Seq_TpsY(5)-3):(Seq_TpsY(5)+3),3)=255;
outImg((Seq_TpsX(5)+3),(Seq_TpsY(5)-3):(Seq_TpsY(5)+3),3)=255;
axes(handles.axes5);
outImg = imcomplement(outImg);
imshow(outImg);
title('False Positive Suppression');
imwrite(outImg,'SeqFpsRes.jpg','jpg');
pause(4);
msgbox('False positive suppression successfully completed');
pause(4);
PerformanceMetrics
