function varargout = MainView(varargin)
% MAINVIEW MATLAB code for MainView.fig
%      MAINVIEW, by itself, creates a new MAINVIEW or raises the existing
%      singleton*.
%
%      H = MAINVIEW returns the handle to a new MAINVIEW or the handle to
%      the existing singleton*.
%
%      MAINVIEW('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MAINVIEW.M with the given input arguments.
%
%      MAINVIEW('Property','Value',...) creates a new MAINVIEW or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before MainView_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to MainView_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help MainView

% Last Modified by GUIDE v2.5 30-Mar-2021 14:14:28

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @MainView_OpeningFcn, ...
                   'gui_OutputFcn',  @MainView_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before MainView is made visible.
function MainView_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to MainView (see VARARGIN)

% Choose default command line output for MainView
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes MainView wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = MainView_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cd Test_Images
[filename, pathname] = uigetfile('*.jpg;*.bmp;*.pgm', 'Select input image data');
    if isequal(filename,0) || isequal(pathname,0)
       warndlg('User pressed cancel');
    else        
        I2 = imread([pathname,filename]);
        imwrite(I2,'InputImg.jpg','jpg');
        axes(handles.axes1);
        imshow(I2);
        title('Input Image');
        pause(4);
        msgbox('The selected input image loaded successfully');
    end    
cd ..

% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cd Test_Images
InputImagData = im2double(imread('InputImg.jpg'));
cd ..
M = 0;
V = 0.02;
InputImagData = imnoise(InputImagData, 'gaussian', M, V);
InitWindowSize = 7;
[FilteringRes, noise] = wiener2(InputImagData, [InitWindowSize, InitWindowSize]);
axes(handles.axes2);
imshow(InputImagData);
title('Noisy Image');
axes(handles.axes3);
imwrite(FilteringRes,'noiseRmvRes1.jpg','jpg');
imshow(FilteringRes);
title('Noise Removal Result');
pause(4);
msgbox('First constraint: Noise removal successfully completed');

% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

InputImagData = im2double(imread('noiseRmvRes1.jpg'));
randDataVal = randn(256,3);
TreeSearchVal = KDTreeSearcher(randDataVal);
RadVal = 1.0;
OptimizedMaxRes = 8;
for i=1:size(randDataVal, 1)
    OptimumPixels = [randDataVal(i,1) randDataVal(i,2) randDataVal(i,3)];
    randPixels = 1;
    if size(randPixels, 1) == 1
        continue;
    end
    nx = 0;
    ny = 1;
    nz = 3;
end
normData = [0 1 3];
for i=1:size(randDataVal, 1)
    OptimumPixels = [randDataVal(i,1) randDataVal(i,2) randDataVal(i,3)];
    [c1(i), c2(i)] = EstimCurvature(normData, TreeSearchVal, OptimumPixels, RadVal);
    k(i) = c1(i)*c2(i);
end
ImgAdjustVal = imadjust(InputImagData);
ContrastEnhacement = imsharpen(ImgAdjustVal);
imwrite(ContrastEnhacement,'ContrastEnhancementRes2.jpg','jpg');
axes(handles.axes4);
imshow(ContrastEnhacement);
title('Contrast Enhancement');
pause(4);
msgbox('Second constraint: Contrast enhancement successfully completed');

% --- Executes on button press in pushbutton5.
function pushbutton5_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

cd Test_Images
InputImagData = imread('InputImg.jpg');
cd ..
computeHistogramVal=imhist(InputImagData); 
sumHistogramVal=sum(computeHistogramVal); 
max=0; 
for i=1:256
    ProbVal(i)=computeHistogramVal(i)/sumHistogramVal; 
end
for ThresholdVal=2:255      
    w0=sum(ProbVal(1:ThresholdVal)); 
    w1=sum(ProbVal(ThresholdVal+1:256)); 
    u0=dot([0:ThresholdVal-1],ProbVal(1:ThresholdVal))/w0; 
    u1=dot([ThresholdVal:255],ProbVal(ThresholdVal+1:256))/w1;
    sigma=w0*w1*((u1-u0)^2); 
    if sigma>max 
        max=sigma;
        threshold=ThresholdVal-1; 
    end
end
AdjustImgPixelVal = imadjust(InputImagData,[0.1 0.8],[]);  
binarizationRes = edge(AdjustImgPixelVal,'canny',0.13);
imwrite(binarizationRes,'BinarizationRes3.jpg','jpg');
axes(handles.axes5);
imshow(binarizationRes);
title('Binarization Result');
pause(4);
msgbox('Third constraint: Binarization successfully completed');

% --- Executes on button press in pushbutton6.
function pushbutton6_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

setDirVal = fullfile(toolboxdir('vision'),'visiondata','triangleImages');
ImgDirVal = fullfile(setDirVal,'trainingImages');
cd Test_Images
InputImagData = imread('InputImg.jpg');
cd ..
se = strel('disk',2);    
vesselExtraction = imadjust(InputImagData,[0.1 0.7],[]);
LblDirVal = fullfile(setDirVal,'trainingLabels');
ImgDataStoreVal = imageDatastore(ImgDirVal);
classNames = ["normal","abnormal"];
LblImDs   = [255 0];
PxDsVal = pixelLabelDatastore(LblDirVal,classNames,LblImDs);
ImgSizeInit = [32 32];
numClassVal = 2;
lgraph = unetLayers(ImgSizeInit, numClassVal);
options = trainingOptions('sgdm', ...
    'InitialLearnRate',1e-3, ...
    'MaxEpochs',40, ...
    'VerboseFrequency',10);
fprintf('Attention-based Nested U-Net Layer Graph Properties');
fprintf('\n');
disp(lgraph);
combine(ImgDataStoreVal,PxDsVal);
fprintf('Training Option Properties');
fprintf('\n');
disp(options);
SegRes = edge(vesselExtraction,'canny',0.20);
CoronaryArteryRes = imdilate(SegRes,se);
pause(4);
analyzeNetwork(lgraph);
pause(4);
axes(handles.axes6);
imshow(CoronaryArteryRes);
title('Segmentation Result');
imwrite(CoronaryArteryRes,'segRes.jpg','jpg');
pause(4);
msgbox('Coronary artery vessel extraction (Segmentation) successfully completed');

% --- Executes on button press in pushbutton7.
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

Process

% --- Executes on button press in pushbutton8.
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
