
res = strcat('E:\Multi-Constraints based Deep Learning Model for Automated Segmentation and Diagnosis of Coronary Artery Disease in X-ray Angiographic Images\Code\Proposed\Dataset\');
file = dir(res);
file = file(~[file.isdir]);
NF = length(file);
for k = 1 : NF
    res1 = strcat('E:\Multi-Constraints based Deep Learning Model for Automated Segmentation and Diagnosis of Coronary Artery Disease in X-ray Angiographic Images\Code\Proposed\Dataset\');    
    img = imread(fullfile(res1,file(k).name));    
    img = imbinarize(img,.2);
    img = bwareaopen(img,60);
    layers = [
        imageInputLayer([224 224 3],"Name","Input data")
        convolution2dLayer([3 3],64,"Name","conv1-1","Stride",[2 2])
        reluLayer("Name","relu1_1")
        convolution2dLayer([3 3],64,"Name","conv1-2","Stride",[2 2])
        reluLayer("Name","relu1_2")
        maxPooling2dLayer([3 3],"Name","pool1","Stride",[2 2])
        convolution2dLayer([1 1],128 ,"Name","conv2-1")
        reluLayer("Name","relu2_1")
        convolution2dLayer([1 1],128,"Name","conv2-2")
        reluLayer("Name","relu2_2")
        maxPooling2dLayer([3 3],"Name","pool2","Stride",[2 2])
        convolution2dLayer([1 1],256,"Name","conv3-1")
        reluLayer("Name","relu3_1")
        convolution2dLayer([1 1],256,"Name","conv3-2")
        reluLayer("Name","relu3_2")
        convolution2dLayer([1 1],256,"Name","conv3-3")
        reluLayer("Name","relu3_3")
        maxPooling2dLayer([3 3],"Name","pool3","Stride",[2 2])
        convolution2dLayer([1 1],512,"Name","conv4-1")
        reluLayer("Name","relu4_1")
        convolution2dLayer([1 1],512,"Name","conv4-2")
        reluLayer("Name","relu4_2")
        convolution2dLayer([1 1],512,"Name","conv4-3")
        reluLayer("Name","relu4_3")
        maxPooling2dLayer([3 3],"Name","pool4","Stride",[2 2])
        convolution2dLayer([1 1],512,"Name","conv5-1")
        reluLayer("Name","relu5_1")
        convolution2dLayer([1 1],512,"Name","conv5-2")
        reluLayer("Name","relu5_2")
        convolution2dLayer([1 1],512,"Name","conv5-3")
        reluLayer("Name","relu5_3")
        globalAveragePooling2dLayer("Name","pool5")
        fullyConnectedLayer(4096,"Name","fc6")
        reluLayer("Name","relu6")
        dropoutLayer(0.5,"Name","drop6")
        fullyConnectedLayer(4096,"Name","fc7")
        reluLayer("Name","relu7")
        fullyConnectedLayer(1000,"Name","fc8")
        dropoutLayer(0.5,"Name","drop7")
        softmaxLayer("Name","prob")
        classificationLayer("Name","ClassificationLayer")];
    g = graycomatrix(img);
    stats = graycoprops(g,'Contrast Correlation Energy Homogeneity');
    Artery_Area = bwarea(img);
    [out,LM] = bwferet(img,'MinFeretProperties');
    AngVal = -1*(out.MinAngle(1));
    DiaMVal = out.MinDiameter(1);
    Artery_Length = length(img);
    Contrast = stats.Contrast;
    Correlation = stats.Correlation;
    Energy = stats.Energy;
    Homogeneity = stats.Homogeneity;
    Mean = mean2(img);
    Dispersion = mean2(var(sum(g)));
    Standard_Deviation = std2(g);
    Entropy = entropy(img);
    Eccentricity = mean2(rms(g));
    Convexity = mean2(var(double(g)));
    a = sum(double(img(:)));
    Solidity = 1-(1/(2+a));
    Local_Intensity = 2*(1/(2+a));
    Kurtosis = kurtosis(double(g(:)));
    Skewness = skewness(double(g(:)));
    m = size(g,1);
    n = size(g,2);
    in_diff = 0;
    options = trainingOptions('sgdm', ...
        'MaxEpochs',20,...
        'InitialLearnRate',1e-4, ...
        'Verbose',false, ...
        'Plots','training-progress');
    for i = 1:m
        for j = 1:n
            temp = g(i,j)./(1+(i-j).^2);
            in_diff = in_diff+temp;
        end
    end
    Roundness = double(in_diff);    
    res2 = strcat('E:\Multi-Constraints based Deep Learning Model for Automated Segmentation and Diagnosis of Coronary Artery Disease in X-ray Angiographic Images\Code\Proposed\TrainingResult\FeatureExtraction\');
    fullFileName = fullfile(res2, file(k).name);
    [folder, fn, ext] = fileparts(fullFileName);
    fn = sprintf('%s.mat', fn);
    fullFileName = fullfile(folder, fn);
    save(fullFileName,'Mean','Standard_Deviation','Skewness','Local_Intensity','Kurtosis','Artery_Area','DiaMVal','AngVal','Artery_Length','Eccentricity','Roundness','Solidity','Dispersion','Convexity','Entropy','Correlation','Homogeneity','Contrast','Energy');
end
